unit BigStruc ;

{ collection d'objets de taille norme, et particuliremnt de plus de
  64 ko}

{ - Dfinitions de type T100WordVect (vecteur de Word de 100 lments)
    et compagnie, dont par exemple TWordMaxvect (taille maxi dans 64 ko)
    (c'aurait pu tre des objets mais tant pis)
  - Idem avec Extended, ShortInt...
  - Pointeurs associs
  - Matrices dfinies par une liste Tab de NbVect vecteurs-lignes
    (CONTRAIREMENT A LA CONVENTION MATRICIELLE, LES VECTEURS SONT ICI EN LIGNES)
  - Matrices types T100WordMat (matrices carres 100 x 100), et associs
    du genre TWordMatMax (32760*32760 * 2 = 2 Go ...), qu'on peut parfois
    utiliser en rectangulaire par Init (NbVect = 9, Base = 10000), ce qui
    donne 9 vecteurs-lignes de 10000 (en fait 32000) lments maxi
  - Matrices rectangulaires type TWordMaxMat15, (Base = 15 au +)


  il y a une liste de 64 ko de pointeurs, dont certains seront  nil,
  qui pointent sur des vecteurs-lignes array[1..?] de Single, Word...
   L'Init permet de dfinir NbVect (nb de lignes), la Base
  (=nombre de colonnes), inutile en fait ici, mais peut-tre utile pour
  des objets drivs). Le Done dispose de tout.
  At renvoie une valeur de la matrice, Put permet d'en affecter une.
  Pas de contrle des bornes...
  NB : Base <=0 donne  base la valeur maxi possible (480 pour T480WordMat,
       32760 pour TWordMatMax, 15 pour TWordMax15Mat)

  NB : les mthodes Put et At ne servent pas qu' rendre plus lisible
   les listings (& + faciles  taper) ; elles peuvent tre overrides et
   comprendre des tests de dpassement ou de validit par exemple
  }

interface

{ NB : Ce sont aussi des objets avec Load, Store, Init, Done }

{ les tailles des matrices (ct limit par la taille 32 bits des
  pointeurs de vecteurs}
const
   NbMaxPtr        = 16380 ; { nombre maxi de pointeurs 32 bits dans 64 ko }

   { nombre maxi de variables dans 64 ko pour chaque type }
   CoteSingleMat   = 16383 ; { rels 4 octets = 32 bits }
   CoteShortIntMat = 65530 ; { entier 1 octet }
   CoteWordMat     = 32760 ; { entier 2 octets }
   CoteLongIntMat  = 16380 ; { entier 4 octets }

   CoteExtendedMat = 6553 ; { rels 10 octets }

{ les types vecteurs-objets }
type
 { taille maxi de 64 ko}
  TSingleMaxVect   = array [1..CoteSingleMat] of Single ;
  TExtendedMaxvect = array [1..CoteExtendedMat] of Extended ;

  TShortIntMaxVect = array [1..CoteShortIntMat] of ShortInt ;
  TWordMaxVect     = array [1..CoteWordMat] of Word ;
  TLongIntMaxVect  = array [1..CoteLongIntMat] of LongInt ;

 { tailles + rduites }
  T15WordVect      = array [1..15]  of Word ;

  T480SingleVect   = array [1..480] of Single ;
  T480Extendedvect = array [1..480] of Extended ;
  T480ShortIntVect = array [1..480] of ShortInt ;
  T480WordVect     = array [1..480] of Word ;

  T1000SingleVect  = array [1..1000] of Single;
  T1000ShortIntvect= array [1..1000] of ShortInt ;
  T1000WordVect    = array [1..1000] of Word ;
  T1000LongIntVect = array [1..1000] of LongInt ;

  T5000LongIntVect = array [1..5000] of LongInt ;

  { au besoin, rajouter des tailles de 1000, 5000... }

{ les pointeurs sur les vecteurs }
type
  PSingleMaxVect     = ^TSingleMaxVect ;
  PShortIntMaxVect   = ^TShortIntMaxVect ;
  PWordMaxVect       = ^TWordMaxVect ;

  P15WordVect        = ^T15WordVect ;

  P480SingleVect     = ^T480SingleVect ;
  P480ExtendedVect   = ^T480Extendedvect ;
  P480ShortIntVect   = ^T480ShortIntVect ;
  P480Wordvect       = ^T480WordVect ;

  P1000SingleVect     = ^T1000SingleVect ;
  P1000ShortIntVect   = ^T1000ShortIntVect ;
  P1000Wordvect       = ^T1000WordVect ;

  P1000LongIntVect    = ^T1000LongIntVect ;
  P5000LongIntVect    = ^T5000LongIntVect ;
{ les matrices (objets) }
type

  TBigMat = Object
    Base : LongInt ;   { nombre de lignes (conv matrices) }
    NbVect : integer ; { nombre de vecteurs (colonnes en matrice) }

    function LinC (x, y : integer) : LongInt ;
     { convention coordonnes cartsiennes : x de 1  Base
                                             y de 1  NbVect
             LinC := x + (y-1)*Base                               }
   end ;


  {SINGLE (rel 4 octets) }

  T480SingleMat = Object (TBigMat)
    Tab : array [1..NbMaxPtr] of P480SingleVect ; { pointeurs sur vecteurs }
    constructor init (N, B : LongInt) ;
    destructor  Done ; virtual ;
    function    At  (i,j : integer) : Single ; virtual ;
    procedure   Put (i,j : integer; n : Single) ; virtual ;
  end ;

  T1000SingleMat = Object (TBigMat)
    Tab : array [1..NbMaxPtr] of P1000SingleVect ; { pointeurs sur vecteurs }
    constructor init (N, B : LongInt) ;
    destructor  Done ; virtual ;
    function    At  (i,j : integer) : Single ; virtual ;
    procedure   Put (i,j : integer; n : Single) ; virtual ;
  end ;

  TSingleMaxMat = Object (TBigMat)
    Tab : array [1..NbMaxPtr] of PSingleMaxVect ; { pointeurs sur vecteurs }
    constructor init (N, B : LongInt) ;
    destructor  Done ; virtual ;
    function    At  (i,j : integer) : Single ; virtual ;
    procedure   Put (i,j : integer; n : Single) ; virtual ;
  end ;

  { EXTENDED : rel 10 octets }
  T480ExtendedMat = Object (TBigMat)
    Tab : array [1..NbMaxPtr] of P480ExtendedVect ; { pointeurs sur vecteurs }
    constructor init (N, B : LongInt) ;
    destructor  Done ; virtual ;
    function    At  (i,j : integer) : Extended ; virtual ;
    procedure   Put (i,j : integer; n : Extended) ; virtual ;
  end ;

{ SHORTINT (entier 1 octet : -128-127}

  T480ShortIntMat = Object (TBigMat)
    Tab : array [1..NbMaxPtr] of P480ShortIntVect ;
    constructor Init (N, B : LongInt);
    destructor  Done ; virtual ;
    function    At(i,j : integer) : ShortInt ; virtual ;
    procedure   Put (i,j : integer; n : ShortInt) ; virtual ;
  end ;

  T1000ShortIntMat = Object (TBigMat)
    Tab : array [1..NbMaxPtr] of P1000ShortIntVect ;
    constructor Init (N, B : LongInt);
    destructor  Done ; virtual ;
    function    At(i,j : integer) : ShortInt ; virtual ;
    procedure   Put (i,j : integer; n : ShortInt) ; virtual ;
  end ;

  TShortIntMaxMat = Object (TBigMat)
    Tab : array [1..NbMaxPtr] of PShortIntMaxVect ;
    constructor Init (N, B : LongInt);
    destructor  Done ; virtual ;
    function    At(i,j : integer) : ShortInt ; virtual ;
    procedure   Put (i,j : integer; n : ShortInt) ; virtual ;
  end ;

{ type WORD (0..65535), taille maxi }

  T480WordMat = Object (TBigMat)
    Tab : array [1..NbMaxPtr] of P480WordVect ;
    constructor Init (N, B : LongInt);
    destructor  Done ; virtual ;
    function    At(i,j : integer) : Word ; virtual ;
    procedure   Put (i,j : integer; n : Word) ; virtual ;
  end ;

  T1000WordMat = Object (TBigMat)
    Tab : array [1..NbMaxPtr] of P1000WordVect;
    constructor Init (N, B : LongInt);
    destructor  Done ; virtual ;
    function    At(i,j : integer) : Word ; virtual ;
    procedure   Put (i,j : integer; n : Word) ; virtual ;
  end ;

  TWordMaxMat = Object (TBigMat)
    Tab : array [1..NbMaxPtr] of PWordMaxVect ;
    constructor Init (N, B : LongInt);
    destructor  Done ; virtual ;
    function    At(i,j : integer) : Word ; virtual ;
    procedure   Put (i,j : integer; n : Word) ; virtual ;
  end ;

  TWordMax15Mat = Object (TBigMat)
    Tab : array [1..NbMaxPtr] of P15WordVect ;
    constructor Init (N, B : LongInt);
    destructor  Done ; virtual ;
    function    At(i,j : integer) : Word ; virtual ;
    procedure   Put (i,j : integer; n : Word) ; virtual ;
  end ;


{ type LongInt (4 octets) }
  T1000LongIntMat = Object (TBigMat)
    Tab : array [1..NbMaxPtr] of P1000LongIntVect ;
    constructor Init (N, B : LongInt);
    destructor  Done ; virtual ;
    function    At(i,j : integer) : LongInt ; virtual ;
    procedure   Put (i,j : integer; n : LongInt) ; virtual ;
  end ;

  T5000LongIntMat = Object (TBigMat)
    Tab : array [1..NbMaxPtr] of P5000LongIntVect ;
    constructor Init (N, B : LongInt);
    destructor  Done ; virtual ;
    function    At(i,j : integer) : LongInt ; virtual ;
    procedure   Put (i,j : integer; n : LongInt) ; virtual ;
  end ;


  { les pointeurs sur les matrices }

  P480SingleMat = ^T480SingleMat ;
  P1000SingleMat = ^T1000SingleMat ;
  PSingleMaxMat = ^TSingleMaxMat ;

  P480ExtendedMat = ^T480ExtendedMat ;

  P480ShortIntMat = ^T480ShortIntMat ;
  P1000ShortIntMat = ^T1000ShortIntMat ;
  PShortIntMaxMat = ^TshortIntMaxMat ;

  P480WordMat = ^T480WordMat ;
  P1000WordMat = ^T1000WordMat ;
  PWordMaxMat  = ^TWordMaxMat ;

  P1000LongIntMat = ^T1000LongIntMat ;

  P5000LongIntMat = ^T5000LongIntMat ;



{********************************************************************}
implementation

function TBigMat.LinC (x, y : integer) : LongInt ;
  begin
    LinC := x + (y-1)*Base
  end ;



{T480SingleMat }

constructor T480SingleMat.Init (N, B : LongInt) ;
 { cre tous les vecteurs }
  var
     i : integer ;
  begin
    if B<=0 then Base := 480  else Base := B ;
    NbVect := N ;
    for i:=1 to Nbvect do
      Tab[i] := New (P480SingleVect) ;
  end ;

destructor T480SingleMat.Done ;
 { dispose de tous les vecteurs }
  var
     i : integer ;
  begin
    for i:=NbVect downto 1 do
      Dispose (Tab[i]) ;
  end ;

function T480SingleMat.At (i,j : integer) : Single ;
  begin
    At := Tab[i]^[j]
  end;

procedure T480SingleMat.Put (i,j: integer; n : Single) ;
  begin
    Tab[i]^[j] := n
  end;

{ T480ExtendedMat }
constructor T480ExtendedMat.Init (N, B : LongInt) ;
 { cre tous les vecteurs }
  var
     i : integer ;
  begin
    if B<=0 then Base := 480  else Base := B ;
    NbVect := N ;
    for i:=1 to Nbvect do
        Tab[i] := New (P480ExtendedVect) ;
  end ;

destructor T480ExtendedMat.Done ;
 { dispose de tous les vecteurs }
  var
     i : integer ;
  begin
    for i:=NbVect downto 1 do
      Dispose (Tab[i]) ;
  end ;

function T480ExtendedMat.At (i,j : integer) : Extended ;
  begin
    At := Tab[i]^[j]
  end;

procedure T480ExtendedMat.Put (i,j: integer; n : Extended) ;
  begin
    Tab[i]^[j] := n
  end;

procedure T480ExtendedMat.AtLin (lin : integer) : Extended ;
  begin
    j := 1 + (lin div Base);
    i := lin - (j-1)*Base ;
    At := Tab[i]^[j]
  end ;

procedure T480ExtendedMat.PutLin (lin : integer; n : Extended) ;
  begin
    j := 1 + (lin div Base);
    i := lin - (j-1)*Base ;
    Tab[i]^[j] := n
  end;


{ T1000SingleMat }

constructor T1000SingleMat.Init (N, B : LongInt) ;
 { cre tous les vecteurs }
  var
     i : integer ;
  begin
    if B<=0 then Base := 1000  else Base := B ;
    NbVect := N ;
    for i:=1 to Nbvect do
        Tab[i] := New (P1000SingleVect) ;
  end ;

destructor T1000SingleMat.Done ;
 { dispose de tous les vecteurs }
  var
     i : integer ;
  begin
    for i:=NbVect downto 1 do
      Dispose (Tab[i]) ;
  end ;

function T1000SingleMat.At (i,j : integer) : Single ;
  begin
    At := Tab[i]^[j]
  end;

procedure T1000SingleMat.Put (i,j: integer; n : Single) ;
  begin
    Tab[i]^[j] := n
  end;

{ TSingleMaxMat }
constructor TSingleMaxMat.Init (N, B : LongInt) ;
 { cre tous les vecteurs }
  var
     i : integer ;
  begin
    if B<=0 then Base :=CoteSingleMat else Base := B ;
    NbVect := N ;
    for i:=1 to Nbvect do
      Tab[i] := New (PSingleMaxVect) ;
  end ;

destructor TSingleMaxMat.Done ;
 { dispose de tous les vecteurs }
  var
     i : integer ;
  begin
    for i:=NbVect downto 1 do
      Dispose (Tab[i]) ;
  end ;

function TSingleMaxMat.At (i,j : integer) : Single ;
  begin
    At := Tab[i]^[j]
  end;

procedure TSingleMaxMat.Put (i,j: integer; n : Single) ;
  begin
    Tab[i]^[j] := n
  end;


{ T480ShortIntMat }

constructor T480ShortIntMat.Init (N, B : LongInt) ;
 { cre tous les vecteurs }
  var
     i : integer ;
  begin
    if B<=0 then Base := 480  else Base := B ;
    NbVect := N ;
    for i:=1 to Nbvect do
       Tab[i] := New (P480ShortIntVect) ;
  end ;

destructor T480ShortIntMat.Done ;
 { dispose de tous les vecteurs }
  var
     i : integer ;
  begin
    for i:=NbVect downto 1 do
      Dispose (Tab[i]) ;
  end ;

function T480ShortIntMat.At (i,j : integer) : ShortInt ;
  begin
    At := Tab[i]^[j]
  end;

procedure T480ShortIntMat.Put (i,j: integer; n : ShortInt) ;
  begin
    Tab[i]^[j] := n
  end;

{ T1000ShortIntMat }

constructor T1000ShortIntMat.Init (N, B : LongInt) ;
 { cre tous les vecteurs }
  var
     i : integer ;
  begin
    if B<=0 then Base := 1000 else Base := B ;
    NbVect := N ;
    for i:=1 to Nbvect do
       Tab[i] := New (P1000ShortIntVect) ;
  end ;

destructor T1000ShortIntMat.Done ;
 { dispose de tous les vecteurs }
  var
     i : integer ;
  begin
    for i:=NbVect downto 1 do
      Dispose (Tab[i]) ;
  end ;

function T1000ShortIntMat.At (i,j : integer) : ShortInt ;
  begin
    At := Tab[i]^[j]
  end;

procedure T1000ShortIntMat.Put (i,j: integer; n : ShortInt) ;
  begin
    Tab[i]^[j] := n
  end;

 { TShortIntMaxMat }

constructor TShortIntMaxMat.Init (N, B : LongInt) ;
 { cre tous les vecteurs }
  var
     i : integer ;
  begin
    if B<=0 then Base := CoteShortIntMat else Base := B ;
    NbVect := N ;
    for i:=1 to Nbvect do
       Tab[i] := New (PShortIntMaxVect) ;
  end ;

destructor TShortIntMaxMat.Done ;
 { dispose de tous les vecteurs }
  var
     i : integer ;
  begin
    for i:=NbVect downto 1 do
      Dispose (Tab[i]) ;
  end ;

function TShortIntMaxMat.At (i,j : integer) : ShortInt ;
  begin
    At := Tab[i]^[j]
  end;

procedure TShortIntMaxMat.Put (i,j: integer; n : ShortInt) ;
  begin
    Tab[i]^[j] := n
  end;

{ T480WordMat }

constructor T480WordMat.Init (N, B : LongInt) ;
 { cre tous les vecteurs }
  var
     i : integer ;
  begin
    if B<=0 then Base := 480  else Base := B ;
    NbVect := N ;
    for i:=1 to Nbvect do
       Tab[i] := New (P480WordVect) ;
  end ;

destructor T480WordMat.Done ;
 { dispose de tous les vecteurs }
  var
     i : integer ;
  begin
    for i:=NbVect downto 1 do
      Dispose (Tab[i]) ;
  end ;

function T480WordMat.At (i,j : integer) : Word ;
  begin
    At := Tab[i]^[j]
  end;

procedure T480WordMat.Put (i,j: integer; n : Word);
  begin
    Tab[i]^[j] := n
  end;

{ T1000WordMat }

constructor T1000WordMat.Init (N, B : LongInt) ;
 { cre tous les vecteurs }
  var
     i : integer ;
  begin
    if B<=0 then Base := 1000  else Base := B ;
    NbVect := N ;
    for i:=1 to Nbvect do
       Tab[i] := New (P1000WordVect) ;
  end ;

destructor T1000WordMat.Done ;
 { dispose de tous les vecteurs }
  var
     i : integer ;
  begin
    for i:=NbVect downto 1 do
      Dispose (Tab[i]) ;
  end ;

function T1000WordMat.At (i,j : integer) : Word ;
  begin
    At := Tab[i]^[j]
  end;

procedure T1000WordMat.Put (i,j: integer; n : Word) ;
  begin
    Tab[i]^[j] := n
  end;

{ TWordMaxMat }

constructor TWordMaxMat.Init (N, B : LongInt) ;
 { cre tous les vecteurs }
  var
     i : integer ;
  begin
    if B<=0 then Base := CoteWordMat else Base := B ;
    NbVect := N ;
    for i:=1 to Nbvect do
      Tab[i] := New (PWordMaxVect)
  end ;

destructor TWordMaxMat.Done ;
 { dispose de tous les vecteurs }
  var
     i : integer ;
  begin
    for i:=NbVect downto 1 do
      Dispose (Tab[i]) ;
  end ;

function TWordMaxMat.At (i,j : integer) : Word ;
  begin
    At := Tab[i]^[j]
  end;

procedure TWordMaxMat.Put (i,j: integer; n : Word) ;
  begin
    Tab[i]^[j] := n
  end;

{ TWordMax15Mat }

constructor TWordMax15Mat.Init (N, B : LongInt) ;
 { cre tous les vecteurs }
  var
     i : integer ;
  begin
    if B<=0 then Base := 15 else Base := B ;

    NbVect := N ;
    for i:=1 to Nbvect do
      Tab[i] := New (P15WordVect);
  end ;

destructor TWordMax15Mat.Done ;
 { dispose de tous les vecteurs }
  var
     i : integer ;
  begin
    for i:=NbVect downto 1 do
      Dispose (Tab[i]) ;
  end ;

function TWordMax15Mat.At (i,j : integer) : Word ;
  begin
    At := Tab[i]^[j]
  end;

procedure TWordMax15Mat.Put (i,j: integer; n : Word) ;
  begin
    Tab[i]^[j] := n
  end;



{ T1000LongIntMat }

constructor T1000LongIntMat.Init (N, B : LongInt) ;
 { cre tous les vecteurs }
  var
     i : integer ;
  begin
    if B<=0 then Base := 1000 else Base := B ;
    NbVect := N ;
    for i:=1 to Nbvect do
       Tab[i] := New (P1000LongINtVect) ;
  end ;

destructor  T1000LongIntMat.Done ;
 { dispose de tous les vecteurs }
  var
     i : integer ;
  begin
    for i:=NbVect downto 1 do
      Dispose (Tab[i]) ;
  end ;

function  T1000LongIntMat.At (i,j : integer) : LongInt ;
  begin
    At := Tab[i]^[j]
  end;

procedure  T1000LongIntMat.Put (i,j: integer; n : LongInt) ;
  begin
    Tab[i]^[j] := n
  end;


{ T5000LongIntMat }

constructor T5000LongIntMat.Init (N, B : LongInt) ;
 { cre tous les vecteurs }
  var
     i : integer ;
  begin
    if B<=0 then Base := 5000 else Base := B ;
    NbVect := N ;
    for i:=1 to Nbvect do
       Tab[i] := New (P5000LongINtVect) ;
  end ;

destructor  T5000LongIntMat.Done ;
 { dispose de tous les vecteurs }
  var
     i : integer ;
  begin
    for i:=NbVect downto 1 do
      Dispose (Tab[i]) ;
  end ;

function  T5000LongIntMat.At (i,j : integer) : LongInt ;
  begin
    At := Tab[i]^[j]
  end;

procedure  T5000LongIntMat.Put (i,j: integer; n : LongInt) ;
  begin
    Tab[i]^[j] := n
  end;


{******************************************************************}
begin

end.