
UNIT Del_io ;

{ unit sur les I/O }

INTERFACE

uses WinDOS, WinTypes ;

TYPE

  TPathName   = Array [0..fsPathName] of Char ;
  TDirectory  = Array [0..fsDirectory] of Char ;
  TName8      = Array [0..8] of Char ;
  TExtension  = Array [0..3] of Char;
  { NB : ancien nom de TExtension : TExt, mais a interfrait
    avec le type 'text' (ASCII) de base }

function  StrUpper ( const l : String ) : String ;
{ Upcase pour toute une string}

{conversions}
function  Chaine     (r : Real )    : String ;
function  ChaineInt  (r : LongInt ) : String ;
function  ChaineReal (r : Real; nbc, nbd : Integer) : String;

{ Convertit l'entier N en tableau de caractres C. Si LongMax > 0, il est
  rempli avec des 0 ; C doit avoir dj trouv une place en mmoire !}
procedure Int2Str(N, LongMax: Integer; C: PChar);

{ renvoie 'oui' ou 'non' selon valeur du booleen }
function OuiNon (toto : Boolean) : String ;

{ petites routines d'affichage }
{ nouvelles, prfrables }
procedure YesBox (const chaine : String) ;  { Oui }
procedure YesBox2 (const texte1, texte2 : String) ;
procedure StopBox (const chaine : String) ;{ stop & cancel }
procedure ExclamBox (const chaine : String) ;{ ! & cancel }

procedure RealBox (const commentaire : String; x : Extended);


{ anciennes botes de dialogue}
   procedure OkBox (txt, title : PChar ) ;
   procedure BoiteInteger (HW: HWnd; num: LongInt; commentaire, titre : PChar);
{ subroutines sur les fichiers du BP7, gards pour la compatibilit;
  ne plus utiliser}
 Var
  { variables utilitaires, remplies ds qu'on a appel un des trucs de
    W_IO ( part wio_resultat)  ET DONC MODIFIEE A N'IMPORTE QUEL MOMENT
    (penser que des sous-programmes peuvent faire ce qu'ils veulent}
   wio_NomComplet, wio_Resultat : TPathName ;
   wio_Dir                      : TDirectory ;
   wio_Nom8                     : TName8 ;
   wio_Extension                : TExtension ;
procedure ExtraitTout   (fichier : PChar) ;
function  ExisteFichier (fichier : PChar) : Boolean ;
function  ExisteDir     (nom : PChar) : Boolean ;
function  FichierCache (nom : PChar) : Boolean ;
function  ReadOnly     (nom : PChar) : Boolean;
function  FichSyst     (nom : PChar) : Boolean ;
procedure InitAttributs (var F: file) ;
function  DriveOf (fich : PChar) : Word ;
 { param : un path ou nom de fichier ; renvoie 1=A:\, 2=B:\...}
procedure ElimAntiSlash (Path : PChar) ;
 { supprime le slash final ventuel, sauf pour X:\ }
procedure ElimAllAntiSlash (Path : PChar) ;
 { idem, mme pour X:\ }


{**********************************************************}
IMPLEMENTATION

uses Strings, WinProcs, Dialogs ;


function StrUpper ( const l : String ) : String ;
  { remplace toutes les minuscules par des majuscules }
  Var c : Char ;
      l2 : string ;
      i : Integer ;
  begin
    l2[0] := l[0] ;   { recopie la longueur de la chane}
    For i := 1 to ord(l2[0]) do
      l2[i] := UpCase(l[i]);
    StrUpper := l2 ;
  end ;

{--------------------- Procdures d'affichage -----------------------------}

function Chaine ( r: Real) : String ;
  var S : string;
  Begin
    Str(r,S) ;
    Chaine := S ;
  End ;


function ChaineInt ( r: LongInt) : String ;
  Var S : String ;
  Begin
    Str(r : 10 ,S) ;
    ChaineInt := S ;
  End ;

function ChaineReal ( r : Real; nbc, nbd : Integer ) : String ;
  Var S : String ;
  Begin
    Str(r : nbc : nbd ,S) ;
    ChaineReal := S ;
  End ;

{ Convertit l'entier N en tableau de caractres C. Si LongMax > 0, il est
  rempli avec des 0 ; C doit avoir dj trouv une place en mmoire !}
procedure Int2Str(N, LongMax: Integer; C: PChar);
var
  S: String[6];
begin
  Str(N, S);
  while Length(S) < LongMax do S := '0' + S;
  StrPCopy(C, S)
end;

{ renvoie 'oui' ou 'non' selon valeur du booleen }
function OuiNon (toto : Boolean) : String ;
  begin
    If toto then OuiNon:='Oui'
            else OuiNon:='Non' ;
  end ;


{*******************************************************************}

procedure BoiteInteger (HW : HWnd; num : LongInt ; commentaire, titre : PChar );
 { affiche une bote avec un chiffre dedans
   NB : commentaire & titre sont des PChar ; gaffe si on n'envoie pas
        du texte pur en paramtre }
  var S       : array[0..16] of Char;
      message : array [0..99] of Char ;
      i       : Integer ;
  begin
     StrCopy(message, commentaire);
     Str(num, S);
     StrCat(message, S);
     MessageBox (HW, message, titre,
                 mb_ApplModal or mb_OK);
  end ;

procedure OkBox (txt, title : PChar ) ;
 { affiche une bote simple, avec le texte txt, un bouton Ok, titre title }
 begin
   MessageBox (0, txt, title, mb_ok) ;
 end ;

procedure YesBox (const chaine : String) ;
  begin
    MessageDlg (chaine, mtInformation, [mbYes], 0);
  end ;

procedure YesBox2 (const texte1, texte2 : String) ;
  var chaine : string ;
  begin
    chaine := texte1 + texte2 ;
    MessageDlg (chaine, mtInformation, [mbYes], 0);
  end ;

procedure StopBox (const chaine : String) ;
  begin
    MessageDlg (chaine, mtError, [mbCancel], 0);
  end ;

procedure ExclamBox (const chaine : String) ;
  begin
    MessageDlg (chaine, mtWarning, [mbCancel], 0);
  end ;

procedure RealBox (const commentaire : String; x : Extended);
  var chaine : String ;
  begin
    str(x, chaine);
    chaine := commentaire+chaine;
    MessageDlg (chaine, mtInformation, [mbYes], 0);
  end ;





{**********************************************************************}

procedure ExtraitTout (fichier : PChar);
 { cette procdure remplit tous les champs wio_}
  var F : file  ;
  begin
    { nom complet }
    FileExpand (wio_NomComplet, fichier) ;
    { dcomposition }
    FileSplit (wio_NomComplet, wio_Dir, wio_Nom8, wio_Extension) ;
  {  MessageBox (0, wio_Dir, wio_NomComplet, mb_OK) ;  }
  end ;

{ Teste l'existence d'un FICHIER (mme sans le path)
  Un rpertoire est considr comme inexistant (il doit de toute manire
  tre l'objet d'un traitement diffrent) (cf EstRepertoire)
  Un fichier cach aussi n'est pas dcel (refaire le test avec
   FichierCache.
  De mme un fichier  lecture seule n'est pas trouv non plus.
  Le fichier ne doit pas avoir t ouvert auparavant (ce qui d'ailleurs
 serait algorithmiquement illogique) }
function ExisteFichier (fichier : PChar) : Boolean ;
  var t11 : TPathName ;
      F : File ;
      i, wbidon : Word ;
  begin
    ExtraitTout (fichier);
    { cherche le fichier }
    StrCopy (t11, wio_Nom8) ;  StrCat (t11, wio_Extension) ;
    FileSearch (wio_Resultat, t11, wio_Dir) ;
    { true si pas chane vide }
  {  MessageBox (0, wio_Resultat, t11, mb_OK); }

    Assign (F , wio_NomComplet );
    {$I-}  { pour dsactiver les erreurs dues au DOS }
    Reset (F) ; { tente une ouverture }
    {$I+} { ractive les erreurs }
    { Rappel : IOResult est rinitialis ds le premier appel !}
    wbidon := IOResult ;
{    BoiteInteger(0, wbidon,'IOResult : ',wio_NomComplet); }
    If wbidon = 0
      then begin ExisteFichier := True ; Close(F) ; end
      else ExisteFichier := False ;
  end ;

{ teste si le nom qu'on lui envoie en paramtre existe et si c'est un
rpertoire }
function ExisteDir ( nom : PChar ) : Boolean ;
  var attr : Word   ;
      F : file ;
  begin
    ExtraitTout (nom) ;
    Assign (F, nom) ;
    GetFAttr (F, attr) ;
    ExisteDir := ((attr and faDirectory) = faDirectory) ;
  end ;

function FichierCache  (nom : PChar) : Boolean ;
 { passe  True si le fichier est cach }
  var attr : Word ;
      F : file ;
  begin
    ExtraitTout (nom) ;
    Assign (F, nom) ;
    GetFAttr (F, attr) ;
    FichierCache := ((attr and faHidden) = faHidden);
  end ;

function  ReadOnly (nom : PChar) : Boolean;
 { passe  True si le fichier (ou rpertoire) est  lecture seule }
  var attr : Word ;
     F : file ;
  begin
    ExtraitTout (nom) ;
    Assign (F, nom) ;
    GetFAttr (F, attr) ;
    ReadOnly:= ((attr and faReadOnly) = faReadOnly);
  end ;

function  FichSyst (nom : PChar ) : Boolean ;
 { passe  True si le fichier (ou rpertoire) est systme }
  var attr : Word ;
      F : file ;
  begin
    ExtraitTout (nom) ;
    Assign (F, nom) ;
    GetFAttr (F, attr) ;
    FichSyst := ((attr and faSysFile) = faSysFile);
  end ;

{ remet  zro tous les attributs du fichier (assign) en question }
procedure InitAttributs (var F: file) ;
  begin
    SetFAttr (F,       (not faReadOnly)
                   and (not faHidden)
                   and (not faSysFile)
                   and (not faVolumeID)
                   and (not faDirectory)
                   and (not faArchive)
                   and faAnyFile );          { ce qui fait pile 0 }
  end ;

function  DriveOf (fich : PChar) : Word ;
  var
    NomComplet : Array[0..99] of Char ;
  begin
    if fich[1] = ':' then    { si 1re lettre est bien un path }
      DriveOf := Ord (UpCase(fich[0]))-64
    else begin
      { le path est incomplet, donc on complte }
      FileExpand (NomComplet, fich) ;
      DriveOf := Ord (UpCase(NomComplet[0]))-64 ;
    end ;
  end ;

procedure ElimAntiSlash (Path : PChar) ;
  var
    l : LongInt  ;
  begin
   { si le chemin n'est PAS du type x:\, et s'il y a un \ final, transformer
     celui-ci en nul de fin de chane }
    l := StrLen (path) ;
    If (path [l-1] = '\') and
       not( (l=3) and (path[2]='\') and (path[1]=':') ) then
         begin
           path [l-1] :=#0 ;  { affecte la chane mme sans var }
         end ;
  end ;

procedure ElimAllAntiSlash (Path : PChar) ;
  var
    l : LongInt  ;
  begin
    { limine l'anti-slash mme pour les paths type C:\ }
    l := StrLen (path) ;
    If (path [l-1] = '\') then
         begin
           path [l-1] :=#0 ;  { affecte la chane mme sans var }
         end ;
  end ;


{***}
end .
